#include "challenges.h"

Challenges::Challenges()
{
	ifstream fic("challenges.bin", ios::in | ios::binary);
	
	texto.push_back("Java Challenge! Supera el nivel 1");
	texto.push_back("C++ Challenge! Supera el nivel 3");
	texto.push_back("Assembler Challenge! Supera el nivel 5");
	texto.push_back("Java Challenge! Termina un nivel en menos de 30 segundos");
	texto.push_back("C++ Challenge! Termina un nivel en menos de 10 segundos");
	texto.push_back("Assembler Challenge! Supera al Maestro Splinter");
	
	bool conseguido;

	if(!fic.is_open())
	{
		for(int i=0;i<=5;i++)
			challenges.push_back(false);
	}
	else
	{
		fic.read((char*)&conseguido, sizeof(bool));
		while(!fic.eof())
		{
			challenges.push_back(conseguido);
			fic.read((char*)&conseguido, sizeof(bool));
		}
		fic.close();
	}
}

Challenges::~Challenges()
{
	ofstream fic("challenges.bin", ios::out | ios::binary);
	
	bool conseguido;

	if(!fic)
		cout << "Se ha producido un error en la apertura del fichero de Challenges" << endl;
	else
	{
		for(unsigned int i=0;i<challenges.size();i++)
		{
			conseguido = challenges[i];
			fic.write((char*)&conseguido, sizeof(bool));
		}
		fic.close();
	}
}

bool 
Challenges::conseguido(int n)
{
	bool retorno = true;
	
	if(challenges[n])
		retorno = false;
	else
		challenges[n] = true;
	
	return retorno;
}

int 
Challenges::ejecutar()
{
	StdPijo& stdp = StdPijo::p();
	
	int retorno = ECHALLENGES;
	
	if(stdp.getKey() == ' ')
		retorno = EMENU;
	
	return retorno;
}

void 
Challenges::mostrar()
{
	StdPijo& stdp = StdPijo::p();
	
	stdp.box(0,0,80,24);
 
	stdp.setColor(ABOLD,CCYAN,CBLACK);
	mvprintw(1,9," ____  _     ____  _     _     _____ _      _____ _____ ____ ");
	mvprintw(2,9,"/   _\\/ \\ /|/  _ \\/ \\   / \\   /  __// \\  /|/  __//  __// ___\\");
	mvprintw(3,9,"|  /  | |_||| / \\|| |   | |   |  \\  | |\\ ||| |  _|  \\  |    \\");
	mvprintw(4,9,"|  \\__| | ||| |-||| |_/\\| |_/\\|  /_ | | \\||| |_//|  /_ \\___ |");
	mvprintw(5,9,"\\____/\\_/ \\|\\_/ \\|\\____/\\____/\\____\\\\_/  \\|\\____\\\\____\\\\____/");
	stdp.setColor(ANORMAL,CWHITE,CBLACK);
	
	for(unsigned int i=0;i<texto.size();i++)
	{
		if(challenges[i])
			stdp.setColor(ANORMAL,CGREEN,CBLACK);
		else
			stdp.setColor(ANORMAL,CRED,CBLACK);

		mvprintw(8+i*2,(80-texto[i].size())/2,texto[i].c_str());
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}
	
	mvprintw(21,21,"Pulse SPACEBAR para volver al menú");
}